#include <FFel.hpp>
#include "gtest/gtest.h"

TEST (FFelTests, Plus){
    FFel one = FFel(1);
    FFel two = FFel(2);
    EXPECT_EQ (one + one, two);
}

TEST (FFelTests, Min){
    FFel one = FFel(1);
    FFel two = FFel(2);
    FFel minusone = FFel(-1);
    EXPECT_EQ(one - two, minusone);
}

TEST (FFelTests, elementsReady){
    EXPECT_FALSE(FFel::elements[2] == 0);
}

TEST (FFelTests, mulAssociative) {
    for (const auto &el1 : FFel::elements) {
        for (const auto &el2 : FFel::elements) {
            for (const auto &el3 : FFel::elements) {
                EXPECT_TRUE((el1*el2)*el3 == el1*(el2*el3));
            }
        }
    }
}

TEST (FFelTetsts, leftDistributive) {
    for (const auto &el1 : FFel::elements) {
        for (const auto &el2 : FFel::elements) {
            for (const auto &el3 : FFel::elements) {
                EXPECT_TRUE(el1*(el2+el3) == el1*el2+el1*el3);
            }
        }
    }
}

TEST (FFelTetsts, rightDistributive) {
    for (const auto &el1 : FFel::elements) {
        for (const auto &el2 : FFel::elements) {
            for (const auto &el3 : FFel::elements) {
                EXPECT_TRUE((el2+el3)*el1 == el1*el2+el1*el3);
            }
        }
    }
}
