#ifndef BSETS2_OPTIONS_H
#define BSETS2_OPTIONS_H

#define ORDER 4
// field specific constants and properties should go in ff/ff*.h files

// do not change anything below this line

/**
 * Order of the finite field / projective plane. Currently only 3, 5, 7, 8 are supported
 */
constexpr int Q = ORDER;

/**
 * Number of points in the plane (= number of lines)
 */
constexpr int NOP = Q * Q + Q + 1;

/**
 * Size of the stabilizer group of a point in the plane.
 */
constexpr int SGS_SIZE = Q * Q * Q * (Q - 1) * (Q * Q - 1);

/**
 * Size of the group PGL(3,q)
 */
constexpr int GROUP_SIZE = SGS_SIZE * NOP;

#endif //BSETS2_OPTIONS_H
